﻿Imports System.Data.OleDb
Imports System.IO
Imports Excel = Microsoft.Office.Interop.Excel
Imports System.Xml
Imports System.Xml.Linq
Imports System.Security
Imports System.Security.Cryptography
Imports System.Text
Imports System.Collections.Specialized
Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Windows.Forms
Imports C1.C1Preview
'Imports System.Windows.Forms.DataGridViewLinkColumn
Imports Microsoft.Win32 'NameSpace
Imports System.Reflection
Imports Microsoft.VisualBasic.ControlChars
'Imports CrystalDecisions.Shared
'Imports CrystalDecisions.CrystalReports.Engine
Imports System.Text.RegularExpressions
Imports C1.Win.C1TrueDBGrid

Public Class Form1
    Dim conn As OleDbConnection
    Dim adap As OleDbDataAdapter
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        OpenFileDialog1.InitialDirectory = "C:temp"
        OpenFileDialog1.Filter = "Excel File (*.xlsx)|*.xlsx"

        OpenFileDialog1.ShowDialog()
        TextBox2.Text = OpenFileDialog1.FileName.ToString()
        Button3.Enabled = True
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Dim destinationPathWithSourceName As String = IO.Path.Combine(Application.StartupPath, IO.Path.GetFileName(TextBox2.Text))
        Dim destinationPathWithDestName As String = IO.Path.Combine(Application.StartupPath, IO.Path.GetFileName("Data.xlsx"))
        If IO.File.Exists(destinationPathWithSourceName) Then
            If MessageBox.Show("Destination already exists!" & vbCrLf & vbCrLf & "File: " & destinationPathWithSourceName, "Replace File?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                IO.File.Copy(TextBox2.Text, destinationPathWithSourceName, True)
                If File.Exists(destinationPathWithDestName) Then    'Delete Data.xls if it already exists
                    My.Computer.FileSystem.DeleteFile(destinationPathWithDestName)
                End If
                My.Computer.FileSystem.RenameFile(destinationPathWithSourceName, "Data.xlsx")
                ' namesheet()
                makeDataTableFromSheetNameUpload()
                loadgrid()

            End If

        Else
            IO.File.Copy(TextBox2.Text, destinationPathWithSourceName)
            If File.Exists(destinationPathWithDestName) Then    'Delete Data.xlsx if it already exists
                My.Computer.FileSystem.DeleteFile(destinationPathWithDestName)
            End If
            My.Computer.FileSystem.RenameFile(destinationPathWithSourceName, "Data.xlsx")
            'namesheet()
            makeDataTableFromSheetNameUpload()
            loadgrid()
        End If
        For i As Integer = 0 To C1TrueDBGrid1.Splits(0).Rows.Count - 1
            C1TrueDBGrid1.Splits(0).Rows(i).AutoSize()
        Next

        'For i As Integer = 0 To C1TrueDBGrid1.Columns.Count - 1
        'C1MultiSelect1.Items.Add(C1TrueDBGrid1.Columns(i).Caption)
        ' Next
        C1MultiSelect1.TagWrap = True
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        OpenFileDialog1.InitialDirectory = "C:temp"
        OpenFileDialog1.Filter = "Excel File (*.xlsx)|*.xlsx"

        OpenFileDialog1.ShowDialog()
        TextBox3.Text = OpenFileDialog1.FileName.ToString()
        Button6.Enabled = True
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        Dim destinationPathWithSourceName As String = IO.Path.Combine(Application.StartupPath, IO.Path.GetFileName(TextBox3.Text))
        Dim destinationPathWithDestName As String = IO.Path.Combine(Application.StartupPath, IO.Path.GetFileName("DataA.xlsx"))
        If IO.File.Exists(destinationPathWithSourceName) Then
            If MessageBox.Show("Destination already exists!" & vbCrLf & vbCrLf & "File: " & destinationPathWithSourceName, "Replace File?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                IO.File.Copy(TextBox3.Text, destinationPathWithSourceName, True)
                If File.Exists(destinationPathWithDestName) Then    'Delete Data.xls if it already exists
                    My.Computer.FileSystem.DeleteFile(destinationPathWithDestName)
                End If
                My.Computer.FileSystem.RenameFile(destinationPathWithSourceName, "DataA.xlsx")
                ' namesheet()
                makeDataTableFromSheetNameUpload()
                loadgrid()
            End If
        Else
            IO.File.Copy(TextBox3.Text, destinationPathWithSourceName)
            If File.Exists(destinationPathWithDestName) Then    'Delete Data.xlsx if it already exists
                My.Computer.FileSystem.DeleteFile(destinationPathWithDestName)
            End If
            My.Computer.FileSystem.RenameFile(destinationPathWithSourceName, "DataA.xlsx")
            'namesheet()
            makeDataTableFromSheetNameUploadA()
            loadgridA()

            'Load Multiselect control
            For i As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
                For j As Integer = 0 To C1TrueDBGrid2.Splits(0).DisplayColumns.Count - 1
                    If C1TrueDBGrid1.Splits(0).DisplayColumns(i).Name = C1TrueDBGrid2.Splits(0).DisplayColumns(j).Name Then
                        C1MultiSelect1.Items.Add(C1TrueDBGrid1.Splits(0).DisplayColumns(i).Name)
                        Exit For
                    End If
                Next
            Next
            C1MultiSelect1.TagWrap = True
        End If

        For i As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
            C1TrueDBGrid5.Columns.Add(New C1DataColumn(C1TrueDBGrid1.Splits(0).DisplayColumns(i).Name, C1TrueDBGrid1.Splits(0).DisplayColumns(i).DataColumn.DataType))
        Next
        C1TrueDBGrid5.SetDataBinding()
    End Sub
    Private Function makeDataTableFromSheetNameUpload() As DataSet
        Try
            Dim ds As DataSet = New DataSet()
            Dim DestinationPath As String = IO.Path.Combine(Application.StartupPath + "\Data.xlsx")
            conn = New System.Data.OleDb.OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0; " & "data source='" & DestinationPath & "';" & "Extended Properties=""Excel 12.0;HDR=YES;IMEX=1"" ")
            conn.Open()
            Dim dt As New DataTable()
            Dim sheetName As String = getSheetName(conn) 'Karrtik: Invoke the new function to get the first sheet name
            adap = New System.Data.OleDb.OleDbDataAdapter("select * from [" & sheetName & "]", conn)
            adap.Fill(dt)
            ds.Tables.Add(dt)
            conn.Close()
            ds.Tables(0).WriteXml(Application.StartupPath + "\Data.xml")
            Return ds
        Catch
            MsgBox(Err.Description)
        End Try
    End Function
    Private Function makeDataTableFromSheetNameUploadA() As DataSet
        Try
            Dim ds As DataSet = New DataSet()
            Dim DestinationPath As String = IO.Path.Combine(Application.StartupPath + "\DataA.xlsx")
            conn = New System.Data.OleDb.OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0; " & "data source='" & DestinationPath & "';" & "Extended Properties=""Excel 12.0;HDR=YES;IMEX=1"" ")
            conn.Open()
            Dim dt As New DataTable()
            Dim sheetName As String = getSheetName(conn) 'Karrtik: Invoke the new function to get the first sheet name
            adap = New System.Data.OleDb.OleDbDataAdapter("select * from [" & sheetName & "]", conn)
            adap.Fill(dt)
            ds.Tables.Add(dt)
            conn.Close()
            ds.Tables(0).WriteXml(Application.StartupPath + "\DataA.xml")
            Return ds
        Catch
            MsgBox(Err.Description)
        End Try

    End Function
    Private Function getSheetName(objConn As OleDbConnection) As String
        Dim strSheetName As String = String.Empty
        Dim dtSheetNames As DataTable = objConn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, Nothing, "TABLE"})
        If dtSheetNames.Rows.Count > 0 Then
            Dim rowCollection As DataRowCollection = dtSheetNames.Rows
            strSheetName = rowCollection(0).Item("TABLE_NAME")
        End If
        Return strSheetName
    End Function
    Private Sub loadgrid()

        Dim xdoc = XDocument.Load(Application.StartupPath + "\Data.xml")

        Dim result = (From n In xdoc.Descendants("NSN")
                      Select n).ToList()
        '' Reformat the Text in NSC node                                                                                                             
        result.ForEach(Sub(nsc) nsc.Value = Regex.Replace(nsc.Value, "(\d{4})(\d{2})(\d{3})(\d{4})", "$1-$2-$3-$4"))

        xdoc.Save(Application.StartupPath + "\Data.xml")
        'MsgBox("hhh")
        Dim xmlPath1 As String
        Dim dtsetcol1 As New DataSet
        'Load Grrid
        xmlPath1 = System.IO.Path.Combine(Application.StartupPath + "\Data.xml")  'grid1
        dtsetcol1.Clear()
        dtsetcol1.ReadXml(xmlPath1)
        'MsgBox(dtsetcol1.Tables(0))
        Me.C1TrueDBGrid1.DataSource = dtsetcol1.Tables(0)
        If dtsetcol1.Tables(0).Rows.Count > 0 Then
            C1TrueDBGrid1.Enabled = True

        End If
    End Sub
    Private Sub loadgridA()
        Dim xdoc = XDocument.Load(Application.StartupPath + "\Data.xml")
        Dim result = (From n In xdoc.Descendants("NSN")
                      Select n).ToList()
        '' Reformat the Text in NSC node                                                                                                             
        result.ForEach(Sub(nsc) nsc.Value = Regex.Replace(nsc.Value, "(\d{4})(\d{2})(\d{3})(\d{4})", "$1-$2-$3-$4"))

        xdoc.Save(Application.StartupPath + "\Data.xml")
        Dim xmlPath1 As String
        Dim dtsetcol1 As New DataSet
        'Load Grrid
        xmlPath1 = System.IO.Path.Combine(Application.StartupPath + "\DataA.xml")  'grid1
        dtsetcol1.Clear()
        dtsetcol1.ReadXml(xmlPath1)
        Me.C1TrueDBGrid2.DataSource = dtsetcol1.Tables(0)
    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        C1TrueDBGrid5.Rows.Clear()
        Dim b As Boolean() = New Boolean(C1MultiSelect1.SelectedItems.Count - 1) {}
        'If any column is selected by C1MultiSelect
        If C1MultiSelect1.SelectedItems.Count > 0 Then
            'Iterate for all rows of main TDB
            For i As Integer = 0 To C1TrueDBGrid1.Splits(0).Rows.Count - 1
                'Iterate for each column selected by C1MultiSelect
                For k As Integer = 0 To C1MultiSelect1.SelectedItems.Count - 1
                    b(k) = False
                    'Iterate with all rows of comparing TDB
                    For j As Integer = 0 To C1TrueDBGrid2.Splits(0).Rows.Count - 1
                        If C1MultiSelect1.SelectedItems(k).Value IsNot Nothing Then
                            If C1TrueDBGrid1.Columns(C1MultiSelect1.SelectedItems(k).Value.ToString).CellText(i) = C1TrueDBGrid2.Columns(C1MultiSelect1.SelectedItems(k).Value.ToString).CellText(j).ToString Then
                                b(k) = True
                                Exit For
                            End If
                        End If
                    Next
                Next
                '  MsgBox("lll")
                'And Filter
                If RadioButton2.Checked Then
                    'And Filter
                    Dim temp = False
                    For l As Integer = 0 To b.Count - 1
                        If b(l) = False Then
                            temp = True
                            Exit For
                        End If
                    Next
                    If Not temp Then
                        Dim dr As DataRow = Me.C1TrueDBGrid5.NewRow
                        For row As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
                            dr(row) = C1TrueDBGrid1.Splits(0).DisplayColumns(row).DataColumn.CellText(i)
                        Next
                        C1TrueDBGrid5.Rows.Add(dr)
                    End If
                End If
                'Or Filter
                If RadioButton1.Checked Then
                    Dim temp = True
                    For l As Integer = 0 To b.Count - 1
                        If b(l) = True Then
                            temp = False
                            Exit For
                        End If
                    Next
                    If Not temp Then
                        Dim dr As DataRow = Me.C1TrueDBGrid5.NewRow

                        For row As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
                            dr(row) = C1TrueDBGrid1.Splits(0).DisplayColumns(row).DataColumn.CellText(i)
                        Next
                        C1TrueDBGrid5.Rows.Add(dr)
                    End If
                End If
            Next
        End If


    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        For i As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
            Me.C1TrueDBGrid3.Columns.Add(New C1.Win.C1TrueDBGrid.C1DataColumn(C1TrueDBGrid1.Splits(0).DisplayColumns(i).Name, C1TrueDBGrid1.Splits(0).DisplayColumns(0).DataColumn.DataType))
        Next
        Me.C1TrueDBGrid3.SetDataBinding()
        For i As Integer = 0 To C1TrueDBGrid2.Splits(0).DisplayColumns.Count - 1
            Me.C1TrueDBGrid5.Columns.Add(New C1.Win.C1TrueDBGrid.C1DataColumn(C1TrueDBGrid2.Splits(0).DisplayColumns(i).Name, C1TrueDBGrid2.Splits(0).DisplayColumns(0).DataColumn.DataType))
            Me.C1TrueDBGrid4.Columns.Add(New C1.Win.C1TrueDBGrid.C1DataColumn(C1TrueDBGrid2.Splits(0).DisplayColumns(i).Name, C1TrueDBGrid2.Splits(0).DisplayColumns(0).DataColumn.DataType))
        Next
        Me.C1TrueDBGrid4.SetDataBinding()
        Me.C1TrueDBGrid5.SetDataBinding()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        'Display Merging data from Grids1 & 2

        Dim TDB5DataTable As DataTable = New DataTable()
        For i As Integer = 0 To C1TrueDBGrid5.Splits(0).DisplayColumns.Count - 1
            TDB5DataTable.Columns.Add(New DataColumn(C1TrueDBGrid5.Splits(0).DisplayColumns(i).Name, C1TrueDBGrid5.Splits(0).DisplayColumns(i).DataColumn.DataType))
        Next
        If RadioButton1.Checked Then
            '        MsgBox("MMMM")
            Dim b As Boolean
            For i As Integer = 0 To C1TrueDBGrid1.Splits(0).Rows.Count - 1
                b = False
                If C1TrueDBGrid1.Columns(0).CellText(i) <> "" Then
                    '  MsgBox("JJJJJJJJJJJJJJ")
                    For j As Integer = 0 To C1TrueDBGrid1.Splits(0).Rows.Count - 1
                        If C1TrueDBGrid1.Columns(0).CellText(j) <> "" Then
                            For k As Integer = 0 To C1MultiSelect1.SelectedItems.Count - 1
                                If C1TrueDBGrid1.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(i) = C1TrueDBGrid2.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(j) Then
                                    b = True
                                    Exit For
                                End If
                            Next
                            If b Then
                                Exit For
                            End If
                        End If
                    Next
                    If b Then
                        Dim dr = TDB5DataTable.NewRow()
                        For col As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
                            dr(col) = C1TrueDBGrid1.Splits(0).DisplayColumns(col).DataColumn.CellText(i)
                        Next
                        TDB5DataTable.Rows.Add(dr)
                    End If
                End If
            Next
            'MsgBox("JJJJ")
            For i As Integer = 0 To C1TrueDBGrid2.Splits(0).Rows.Count - 1
                b = False
                If C1TrueDBGrid2.Columns(0).CellText(i) <> "" Then
                    For j As Integer = 0 To C1TrueDBGrid2.Splits(0).Rows.Count - 1
                        If C1TrueDBGrid2.Columns(0).CellText(j) <> "" Then
                            For k As Integer = 0 To C1MultiSelect1.SelectedItems.Count - 1
                                If C1TrueDBGrid2.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(i) = C1TrueDBGrid1.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(j) Then
                                    b = True
                                    Exit For
                                End If
                            Next
                            If b Then
                                Exit For
                            End If
                        End If
                    Next
                    If b Then
                        Dim dr = TDB5DataTable.NewRow()
                        For col As Integer = 0 To C1TrueDBGrid2.Splits(0).DisplayColumns.Count - 1
                            dr(col) = C1TrueDBGrid2.Splits(0).DisplayColumns(col).DataColumn.CellText(i)
                        Next
                        TDB5DataTable.Rows.Add(dr)
                    End If
                End If
            Next
        End If
        ' MsgBox("KKK")

        '===========================================================================
        If RadioButton2.Checked Then
            Dim b As Boolean
            For i As Integer = 0 To C1TrueDBGrid1.Splits(0).Rows.Count - 1
                If C1TrueDBGrid1.Columns(0).CellText(i) <> "" Then
                    b = False
                    For j As Integer = 0 To C1TrueDBGrid2.Splits(0).Rows.Count - 1
                        If C1TrueDBGrid2.Columns(0).CellText(j) <> "" Then
                            For k As Integer = 0 To C1MultiSelect1.SelectedItems.Count - 1
                                If C1TrueDBGrid1.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(i) <> C1TrueDBGrid2.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(j) Then
                                    b = True
                                    Exit For
                                Else
                                    b = False
                                End If
                            Next
                            If Not b Then
                                Exit For
                            End If
                        End If
                    Next
                    If Not b Then
                        Dim dr = TDB5DataTable.NewRow()
                        For col As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
                            dr(col) = C1TrueDBGrid1.Splits(0).DisplayColumns(col).DataColumn.CellText(i)
                        Next
                        TDB5DataTable.Rows.Add(dr)
                    End If
                End If
            Next

            For i As Integer = 0 To C1TrueDBGrid2.Splits(0).Rows.Count - 1
                If C1TrueDBGrid2.Columns(0).CellText(i) <> "" Then
                    b = False
                    For j As Integer = 0 To C1TrueDBGrid1.Splits(0).Rows.Count - 1
                        If C1TrueDBGrid1.Columns(0).CellText(j) <> "" Then
                            For k As Integer = 0 To C1MultiSelect1.SelectedItems.Count - 1
                                If C1TrueDBGrid2.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(i) <> C1TrueDBGrid1.Columns(C1MultiSelect1.SelectedItems(k).Value).CellText(j) Then
                                    b = True
                                    Exit For
                                Else
                                    b = False
                                End If
                            Next
                            If Not b Then
                                Exit For
                            End If
                        End If
                    Next
                    If Not b Then
                        Dim dr = TDB5DataTable.NewRow()
                        For col As Integer = 0 To C1TrueDBGrid2.Splits(0).DisplayColumns.Count - 1
                            dr(col) = C1TrueDBGrid2.Splits(0).DisplayColumns(col).DataColumn.CellText(i)
                        Next
                        TDB5DataTable.Rows.Add(dr)
                    End If
                End If
            Next
        End If
        C1TrueDBGrid5.DataSource = TDB5DataTable
        If C1TrueDBGrid5.Splits(0).Rows.Count = 0 Then
            MsgBox("No Matches Found")
        End If
        '****************************
        '  Exit Sub
        MsgBox(TDB5DataTable.Rows.Count) ' ***** COUNT Is 0
        Dim DataView As DataView = TDB5DataTable.AsDataView()
        DataView.Sort = " NSN ASC"
        C1TrueDBGrid5.DataSource = DataView
        Exit Sub
    End Sub
End Class

